#ifndef _CONFIG_H_INCLUDED
#define _CONFIG_H_INCLUDED

/* QNT - config.h - Configuration file interface. */


#define WIN32_LEAN_AND_MEAN
#include <windows.h>


struct Keys
{
    int k;
    BOOL (Buffer::*f)();
};


class Config
{
    static int pageoverlap;
    static WORD textattr;
    static WORD hiliteattr;
    static WORD statusattr;
    static DWORD autosaveinterval; /* milliseconds */
    static Keys keys[];
public:
    enum
    {
        SHIFT = 0x100,
        CTRL = 0x0200,
        ALT = 0x0400,
        META = 0x0800,
        TOP = 0x1000
    } Shift;
    static int getpageoverlap() { return pageoverlap; }
    static WORD gettextattr() { return textattr; }
    static WORD gethiliteattr() { return hiliteattr; }
    static WORD getstatusattr() { return statusattr; }
    static DWORD getautosaveinterval() { return autosaveinterval; }
    static int shiftxform( int );
    static BOOL mapkey( Buffer *, int );
    static char *genstatusline( BOOL, int, int, char * );
};

inline static BOOL Config::mapkey( Buffer *buffer, int k )
{
    for( int i = 0; keys[i].k; i++ )
        if( k == keys[i].k || k == (keys[i].k | SHIFT) )
        {
            (buffer->*keys[i].f)();
            return TRUE;
        }
    return FALSE;
}


#endif
